#################################
# * Common components for OPM, in particular build system (cmake)
#################################

opm-common:
  extends: .build_aur_template
  tags: [saas-linux-small-amd64]
  stage: .pre
  variables:
    PACKAGE: "opm-common"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "python-portalocker-*.pkg.tar.zst python-pytest-runner-*.pkg.tar.zst dune-common-*.pkg.tar.zst fmt10-*.pkg.tar.zst"
  after_script:
    - sudo pacman -U ${CI_PROJECT_DIR}/${ARCHITECTURE}/*.pkg.tar.zst --noconfirm >/dev/null 2>&1
    - printf 'y\n' | duneproject ${PROJECT} ${DEPENDENCIES} ${VERSION} ${MAINTAINER}
    - cmake -S ${PROJECT} -B build -Wno-dev
    - cmake --build build
    - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
  needs: ["python-portalocker", "python-pytest-runner", "dune-common", "fmt10"]

#################################
# * Common components for OPM, in particular build system (cmake) (python bindings)
#################################

python-opm-common:
  extends: .build_aur_template
  tags: [saas-linux-small-amd64]
  stage: .pre
  variables:
    PACKAGE: "opm-common"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "python-portalocker-*.pkg.tar.zst python-pytest-runner-*.pkg.tar.zst dune-common-*.pkg.tar.zst fmt10-*.pkg.tar.zst"
  after_script:
    - sudo pacman -U ${CI_PROJECT_DIR}/${ARCHITECTURE}/*.pkg.tar.zst --noconfirm >/dev/null 2>&1
    - python -c "import opm"
  needs: ["python-portalocker", "python-pytest-runner", "dune-common", "fmt10"]

#################################
# * DUNE module supporting grids in a corner-point format
#################################

opm-grid:
  extends: .build_aur_template
  tags: [saas-linux-small-amd64]
  stage: .pre
  variables:
    PACKAGE: "opm-grid"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "python-portalocker-*.pkg.tar.zst dune-common-*.pkg.tar.zst dune-geometry-*.pkg.tar.zst dune-uggrid-*.pkg.tar.zst alberta-*.pkg.tar.zst dune-grid-*.pkg.tar.zst dune-istl-*.pkg.tar.zst gklib-*.pkg.tar.zst metis-*.pkg.tar.zst parmetis-git-*.pkg.tar.zst scotch-*.pkg.tar.zst zoltan-*.pkg.tar.zst fmt10-*.pkg.tar.zst opm-common-*.pkg.tar.zst"
  after_script:
    - sudo pacman -U ${CI_PROJECT_DIR}/${ARCHITECTURE}/*.pkg.tar.zst --noconfirm >/dev/null 2>&1
    - printf 'y\n' | duneproject ${PROJECT} ${DEPENDENCIES} ${VERSION} ${MAINTAINER}
    - cmake -S ${PROJECT} -B build -Wno-dev
    - cmake --build build
    - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
  needs:
    [
      "python-portalocker",
      "dune-common",
      "dune-geometry",
      "dune-uggrid",
      "alberta",
      "dune-grid",
      "dune-istl",
      "gklib",
      "metis",
      "parmetis-git",
      "scotch",
      "zoltan",
      "opm-common",
      "fmt10",
    ]

#################################
# * Single-phase and steady-state upscaling methods
#################################

opm-upscaling:
  extends: .build_aur_template
  tags: [saas-linux-small-amd64]
  stage: .pre
  variables:
    PACKAGE: "opm-upscaling"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "python-portalocker-*.pkg.tar.zst dune-common-*.pkg.tar.zst dune-geometry-*.pkg.tar.zst dune-uggrid-*.pkg.tar.zst alberta-*.pkg.tar.zst dune-grid-*.pkg.tar.zst dune-istl-*.pkg.tar.zst gklib-*.pkg.tar.zst metis-*.pkg.tar.zst parmetis-git-*.pkg.tar.zst scotch-*.pkg.tar.zst zoltan-*.pkg.tar.zst fmt10-*.pkg.tar.zst opm-common-*.pkg.tar.zst opm-grid-*.pkg.tar.zst"
  after_script:
    - sudo pacman -U ${CI_PROJECT_DIR}/${ARCHITECTURE}/*.pkg.tar.zst --noconfirm >/dev/null 2>&1
    - printf 'y\n' | duneproject ${PROJECT} ${DEPENDENCIES} ${VERSION} ${MAINTAINER}
    - cmake -S ${PROJECT} -B build -Wno-dev
    - cmake --build build
    - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
  needs:
    [
      "python-portalocker",
      "dune-common",
      "dune-geometry",
      "dune-uggrid",
      "alberta",
      "dune-grid",
      "dune-istl",
      "gklib",
      "metis",
      "parmetis-git",
      "scotch",
      "zoltan",
      "opm-common",
      "fmt10",
      "opm-grid",
    ]
#################################
# * Open porous media / reservoir simulators
#################################

# opm-simulators:
#   extends: .build_aur_template
#   tags: [saas-linux-small-amd64]
#   stage: .pre
#   variables:
#     PACKAGE: "opm-simulators"
#     ISDEPENDS: "true"
#     DEPENDENCIES_PACKAGE: "dune-common-*.pkg.tar.zst dune-geometry-*.pkg.tar.zst dune-uggrid-*.pkg.tar.zst dune-grid-*.pkg.tar.zst dune-istl-*.pkg.tar.zst gklib-*.pkg.tar.zst metis-*.pkg.tar.zst parmetis-git-*.pkg.tar.zst scotch-*.pkg.tar.zst zoltan-*.pkg.tar.zst opm-common-*.pkg.tar.zst fmt10-*.pkg.tar.zst"
#   after_script:
#     - sudo pacman -U ${CI_PROJECT_DIR}/${ARCHITECTURE}/*.pkg.tar.zst --noconfirm >/dev/null 2>&1
#     - printf 'y\n' | duneproject ${PROJECT} ${DEPENDENCIES} ${VERSION} ${MAINTAINER}
#     - cmake -S ${PROJECT} -B build -Wno-dev
#     - cmake --build build
#     - mpirun -np 1 --oversubscribe ./build/src/${PROJECT}
#   needs:
#     [
#       "dune-common",
#       "dune-geometry",
#       "dune-uggrid",
#       "dune-grid",
#       "dune-istl",
#       "gklib",
#       "metis",
#       "parmetis-git",
#       "scotch",
#       "zoltan",
#       "opm-common",
#       "fmt10",
#     ]
